--- include/class.issue.php	2009-01-13 20:09:57.681222753 +0200
+++ /usr/share/eventum/include/class.issue.php	2009-02-05 02:15:18.617317004 +0200
@@ -1660,6 +1634,180 @@
         }
     }
 
+    /**
+     * Method used to update the a single detail field of a specific issue.
+     *
+     * @param integer $issue_id
+     * @param string $field_name
+     * @param string $field_value
+     * @param string $field_type string or integer (for escape)
+     * @return integer 1 on success, -1 otherwise
+     */
+    function updateField($issue_id, $field_name, $filed_value) {
+
+        $issue_id = Misc::escapeInteger($issue_id);
+
+        $usr_id = Auth::getUserID();
+        $prj_id = Issue::getProjectID($issue_id);
+
+        // get all of the 'current' information of this issue
+        $current = Issue::getDetails($issue_id);
+
+        $stmt = "UPDATE
+                    " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "issue
+                 SET
+                    iss_updated_date='" . Date_Helper::getCurrentDateGMT() . "',
+                    iss_last_public_action_date='" . Date_Helper::getCurrentDateGMT() . "',
+                    iss_last_public_action_type='updated'";
+
+        switch ($field_name) {
+            case 'category':
+                $stmt .= ", iss_prc_id = " . Misc::escapeInteger($filed_value);
+            break;
+            case 'release':
+                $stmt .= ", iss_pre_id = " . Misc::escapeInteger($filed_value);
+            break;
+            case 'expected_resolution_date':
+                if (is_null($filed_value)) {
+                    $stmt .= ", iss_expected_resolution_date = null";
+                } else {
+                    $stmt .= ", iss_expected_resolution_date = '" . Misc::escapeString($filed_value) . "'";
+                }
+            break;
+            case 'release':
+                $stmt .= ", iss_pre_id = " . Misc::escapeInteger($filed_value);
+            break;
+            case 'priority':
+                $stmt .= ", iss_pri_id = " . Misc::escapeInteger($filed_value);
+            break;
+            case 'status':
+                $stmt .= ", iss_sta_id = " . Misc::escapeInteger($filed_value);
+            break;
+            case 'resolution':
+                $stmt .= ", iss_res_id = " . Misc::escapeInteger($filed_value);
+            break;
+            case 'summary':
+                $stmt .= ", iss_summary = '" . Misc::escapeString($filed_value) . "'";
+            break;
+            case 'description':
+                $stmt .= ", iss_description = '" . Misc::escapeString($filed_value) . "'";
+            break;
+            case 'estimated_dev_time':
+                $stmt .= ", iss_dev_time = '" . Misc::escapeString($filed_value) . "'";
+            break;
+            case 'percent_complete':
+                $stmt .= ", iss_percent_complete = '" . Misc::escapeString($filed_value) . "'";
+            break;
+            case 'trigger_reminders':
+                $stmt .= ", iss_trigger_reminders = " . Misc::escapeInteger($filed_value);
+            break;
+            case 'group':
+                $stmt .= ", iss_grp_id = " . Misc::escapeInteger($filed_value);
+            break;
+            case 'private':
+                $stmt .= ", iss_private = " . Misc::escapeInteger($filed_value);
+            break;
+            default:
+                Error_Handler::logError("Unknown field name $field_name", __FILE__, __LINE__);
+                return -1;
+            break;
+        }
+
+        $stmt .= "
+                 WHERE
+                    iss_id=$issue_id";
+
+        $res = Db_Helper::getInstance()->query($stmt);
+        if (PEAR::isError($res)) {
+            Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
+            return -1;
+        } else {
+            $new = array(
+                'category' => $current['iss_prc_id'],
+                'release' => $current['iss_pre_id'],
+                'expected_resolution_date' => $current['iss_expected_resolution_date'],
+                'release' => $current['iss_pre_id'],
+                'priority' => $current['iss_pri_id'],
+                'status' => $current['iss_sta_id'],
+                'resolution' => $current['iss_res_id'],
+                'summary' => $current['iss_summary'],
+                'description' => $current['iss_description'],
+                'estimated_dev_time' => $current['iss_dev_time'],
+                'percent_complete' => $current['iss_percent_complete'],
+                'trigger_reminders' => $current['iss_trigger_reminders'],
+                'group' => $current['iss_grp_id'],
+                'iss_private' => $current['private']
+            );
+            $new[$field_name] = $filed_value;
+
+            // add change to the history (only for changes on specific fields?)
+            $updated_fields = array();
+            if ($field_name == 'expected_resolution_date' && $current["iss_expected_resolution_date"] != $filed_value) {
+                $updated_fields["Expected Resolution Date"] = History::formatChanges($current["iss_expected_resolution_date"], $filed_value);
+            }
+            if ($field_name == 'category' && $current["iss_prc_id"] != $filed_value) {
+                $updated_fields["Category"] = History::formatChanges(Category::getTitle($current["iss_prc_id"]), Category::getTitle($filed_value));
+            }
+            if ($field_name == 'release' && $current["iss_pre_id"] != $filed_value) {
+                $updated_fields["Release"] = History::formatChanges(Release::getTitle($current["iss_pre_id"]), Release::getTitle($filed_value));
+            }
+            if ($field_name == 'priority' && $current["iss_pri_id"] != $filed_value) {
+                $updated_fields["Priority"] = History::formatChanges(Priority::getTitle($current["iss_pri_id"]), Priority::getTitle($filed_value));
+                Workflow::handlePriorityChange($prj_id, $issue_id, $usr_id, $current, $new);
+            }
+            if ($field_name == 'status' && $current["iss_sta_id"] != $filed_value) {
+                // clear out the last-triggered-reminder flag when changing the status of an issue
+                Reminder_Action::clearLastTriggered($issue_id);
+
+                // if old status was closed and new status is not, clear closed data from issue.
+                $old_status_details = Status::getDetails($current['iss_sta_id']);
+                if ($old_status_details['sta_is_closed'] == 1) {
+                    $new_status_details = Status::getDetails($filed_value);
+                    if ($new_status_details['sta_is_closed'] != 1) {
+                        Issue::clearClosed($issue_id);
+                    }
+                }
+                $updated_fields["Status"] = History::formatChanges(Status::getStatusTitle($current["iss_sta_id"]), Status::getStatusTitle($filed_value));
+            }
+            if ($field_name == 'resolution' && $current["iss_res_id"] != $filed_value) {
+                $updated_fields["Resolution"] = History::formatChanges(Resolution::getTitle($current["iss_res_id"]), Resolution::getTitle($filed_value));
+            }
+            if ($field_name == 'estimated_dev_time' && $current["iss_dev_time"] != $filed_value) {
+                $updated_fields["Estimated Dev. Time"] = History::formatChanges(Misc::getFormattedTime(($current["iss_dev_time"]*60)), Misc::getFormattedTime(($filed_value*60)));
+            }
+            if ($field_name == 'summary' && $current["iss_summary"] != $filed_value) {
+                $updated_fields["Summary"] = '';
+            }
+            if ($field_name == 'description' && $current["iss_description"] != $filed_value) {
+                $updated_fields["Description"] = '';
+            }
+            if ($field_name == 'private' && ($filed_value != $current['iss_private'])) {
+                $updated_fields["Private"] = History::formatChanges(Misc::getBooleanDisplayValue($current['iss_private']), Misc::getBooleanDisplayValue($filed_value));
+            }
+            if (count($updated_fields) > 0) {
+                // log the changes
+                $changes = '';
+                $i = 0;
+                foreach ($updated_fields as $key => $value) {
+                    if ($i > 0) {
+                        $changes .= "; ";
+                    }
+                    if (($key != "Summary") && ($key != "Description")) {
+                        $changes .= "$key: $value";
+                    } else {
+                        $changes .= "$key";
+                    }
+                    $i++;
+                }
+
+                History::add($issue_id, $usr_id, History::getTypeID('issue_updated'), "Issue updated ($changes) by " . User::getFullName($usr_id));
+                // send notifications for the issue being updated
+                Notification::notifyIssueUpdated($issue_id, $current, $new);
+            }
+        }
+        return 1;
+    }
+
 
     /**
      * Move the issue to a new project
@@ -1676,7 +1824,7 @@
               iss_prj_id = " . Misc::escapeInteger($new_prj_id) . "
           WHERE
               iss_id = " . Misc::escapeInteger($issue_id);
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1710,7 +1858,7 @@
                   iss_pri_id=" . $new_pri_id . "
               WHERE
                   iss_id=$issue_id";
-            $res = $GLOBALS["db_api"]->dbh->query($stmt);
+            $res = Db_Helper::getInstance()->query($stmt);
             if (PEAR::isError($res)) {
                 Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             }
@@ -1742,7 +1890,7 @@
                     $issue_id,
                     $associated_id
                  )";
-        $GLOBALS["db_api"]->dbh->query($stmt);
+        Db_Helper::getInstance()->query($stmt);
         History::add($issue_id, $usr_id, History::getTypeID('issue_associated'), "Issue associated to #$associated_id by " . User::getFullName($usr_id));
         // link the associated issue back to this one
         if ($link_issues) {
@@ -1769,7 +1917,7 @@
                  WHERE
                     isa_issue_id IN ($issue_id) OR
                     isa_associated_id IN ($issue_id)";
-        $GLOBALS["db_api"]->dbh->query($stmt);
+        Db_Helper::getInstance()->query($stmt);
         if ($usr_id) {
             History::add($issue_id, $usr_id, History::getTypeID('issue_all_unassociated'), 'Issue associations removed by ' . User::getFullName($usr_id));
         }
@@ -1799,7 +1947,7 @@
                         isa_issue_id = $associated_id AND
                         isa_associated_id = $issue_id
                     )";
-        $GLOBALS["db_api"]->dbh->query($stmt);
+        Db_Helper::getInstance()->query($stmt);
         History::add($issue_id, Auth::getUserID(), History::getTypeID('issue_unassociated'),
                 "Issue association #$associated_id removed by " . User::getFullName(Auth::getUserID()));
         History::add($associated_id, Auth::getUserID(), History::getTypeID('issue_unassociated'),
@@ -1821,18 +1969,35 @@
     {
         $issue_id = Misc::escapeInteger($issue_id);
         $assignee_usr_id = Misc::escapeInteger($assignee_usr_id);
+        $order = 1;
+        // move all orders down to free "order space" for this new association
+        $stmt = "UPDATE 
+                    " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "issue_user
+                 SET
+                    isu_order = isu_order + 1
+                 WHERE
+                    isu_usr_id = $assignee_usr_id AND
+                    isu_order >= $order";
+        $res = Db_Helper::getInstance()->query($stmt);
+        if (PEAR::isError($res)) {
+            Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
+            return -1;
+        }
+        // insert the new association
         $stmt = "INSERT INTO
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "issue_user
                  (
                     isu_iss_id,
                     isu_usr_id,
-                    isu_assigned_date
+                    isu_assigned_date,
+                    isu_order
                  ) VALUES (
                     $issue_id,
                     $assignee_usr_id,
-                    '" . Date_API::getCurrentDateGMT() . "'
+                    '" . Date_Helper::getCurrentDateGMT() . "',
+                    $order
                  )";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1845,6 +2010,78 @@
         }
     }
 
+    /**
+     * Method used to get the order list to be rearranged
+     * 
+     * @access  private
+     * @param   string $issue_id The issue ID or a comma seperated list of IDs already prepared for giving to mysql
+     * @param   string $usr_id The user to remove. When not specified, all users are taken as to be removed for that issue
+     * @return  mixed delete order list to be rearranged. Used as a parameter to the method of rearranging the order.
+     */
+    function getDeleteUserAssociationOrderList($issue_id, $usr_id = "")
+    {
+        // find all affected associantion orders
+        $stmt = "SELECT isu_usr_id, isu_order FROM
+                    " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "issue_user
+                 WHERE
+                 isu_iss_id IN ($issue_id)";
+        if (!empty($usr_id)) {
+            $stmt.= " AND isu_usr_id IN ($usr_id)";
+        }
+        $stmt.= "ORDER BY isu_order";
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
+        if (PEAR::isError($res)) {
+            Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
+            return -1;
+        } else {
+            $deleted_orders = array();
+            foreach ($res as $row) {
+                if (empty($deleted_orders[$row['isu_usr_id']])) {
+                    $deleted_orders[$row['isu_usr_id']] = array();
+                }
+                $deleted_orders[$row['isu_usr_id']] [] = $row['isu_order'];
+            }
+            return $deleted_orders;
+        }
+    }
+
+    /**
+     *
+     * Method used to rearrange order list in the db according to known deleted records
+     *
+     * @access  private
+     * @param   mixed  deleteorder list
+     * @return void
+     */
+    function rearrangeDeleteUserAssociationOrderList($delete_order_list)
+    {
+        if (empty($delete_order_list) || (!is_array($delete_order_list))) {
+            return -1;
+        }
+        foreach ($delete_order_list as $isu_usr_id => $orders) {
+            for ($i = 0; $i < count($orders); $i++) { // traverse all deleted orders
+                // move the orders after them up to take the "order space" of the deleted records
+                $stmt = "UPDATE
+                            " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "issue_user
+                         SET
+                            isu_order = isu_order - " . ($i+1) . "
+                         WHERE
+                            isu_usr_id = $isu_usr_id AND
+                            isu_order > " . $orders[$i];
+                if ($i < count($orders) - 1) {
+                    $stmt.=  " AND
+                            isu_order < " . $orders[$i+1];
+                }
+                $res = Db_Helper::getInstance()->query($stmt);
+                if (PEAR::isError($res)) {
+                    Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
+                    return -1;
+                }
+            }
+        }
+        return 1;
+    }
+
 
     /**
      * Method used to delete all user assignments for a specific issue.
@@ -1860,11 +2097,12 @@
         if (is_array($issue_id)) {
             $issue_id = implode(", ", $issue_id);
         }
+        $deleted_order_list = Issue::getDeleteUserAssociationOrderList($issue_id);
         $stmt = "DELETE FROM
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "issue_user
                  WHERE
                     isu_iss_id IN ($issue_id)";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1890,12 +2128,13 @@
     {
         $issue_id = Misc::escapeInteger($issue_id);
         $usr_id = Misc::escapeInteger($usr_id);
+        $delete_order_list = Issue::getDeleteUserAssociationOrderList($issue_id, $usr_id);
         $stmt = "DELETE FROM
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "issue_user
                  WHERE
                     isu_iss_id = $issue_id AND
                     isu_usr_id = $usr_id";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1904,6 +2143,7 @@
                 History::add($issue_id, Auth::getUserID(), History::getTypeID('user_unassociated'),
                     User::getFullName($usr_id) . ' removed from issue by ' . User::getFullName(Auth::getUserID()));
             }
+            Issue::rearrangeDeleteUserAssociationOrderList($delete_order_list);
             return 1;
         }
     }
@@ -1928,7 +2168,7 @@
     function createFromEmail($prj_id, $usr_id, $sender, $summary, $description, $category, $priority, $assignment, $date, $msg_id)
     {
         $exclude_list = array();
-        $sender_email = Mail_API::getEmailAddress($sender);
+        $sender_email = Mail_Helper::getEmailAddress($sender);
         $sender_usr_id = User::getUserIDByEmail($sender_email, true);
         if (!empty($sender_usr_id)) {
             $reporter = $sender_usr_id;
@@ -1940,7 +2180,7 @@
                 $contact = Customer::getContactDetails($prj_id, $customer_contact_id);
                 // overwrite the reporter with the customer contact
                 $reporter = User::getUserIDByContactID($customer_contact_id);
-                $contact_timezone = Date_API::getPreferredTimezone($reporter);
+                $contact_timezone = Date_Helper::getPreferredTimezone($reporter);
             }
         } else {
             $customer_id = FALSE;
@@ -2001,14 +2241,14 @@
                     '" . Misc::escapeString($contact_timezone) . "',";
         }
         $stmt .= "
-                    '" . Date_API::getCurrentDateGMT() . "',
-                    '" . Date_API::getCurrentDateGMT() . "',
+                    '" . Date_Helper::getCurrentDateGMT() . "',
+                    '" . Date_Helper::getCurrentDateGMT() . "',
                     'created',
                     '" . Misc::escapeString($summary) . "',
                     '" . Misc::escapeString($description) . "',
                     '" . Misc::escapeString($msg_id) . "'
                  )";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -2194,16 +2434,16 @@
                     '" . Misc::escapeString($_POST["contact_timezone"]) . "',";
         }
         $stmt .= "
-                    '" . Date_API::getCurrentDateGMT() . "',
-                    '" . Date_API::getCurrentDateGMT() . "',
+                    '" . Date_Helper::getCurrentDateGMT() . "',
+                    '" . Date_Helper::getCurrentDateGMT() . "',
                     'created',
                     '" . Misc::escapeString($_POST["summary"]) . "',
                     '" . Misc::escapeString($_POST["description"]) . "',
                     " . Misc::escapeString($_POST["estimated_dev_time"]) . ",
                     " . Misc::escapeInteger($_POST["private"]) . " ,
-                    '" . Misc::escapeString(Mail_API::generateMessageID()) . "'
+                    '" . Misc::escapeString(Mail_Helper::generateMessageID()) . "'
                  )";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -2380,6 +2620,11 @@
     {
         $sort_by = Issue::getParam('sort_by');
         $sort_order = Issue::getParam('sort_order');
+        $users = Issue::getParam('users');
+        if (empty($users) && ($sort_by == 'isu_order')) { // Sorting by isu_order is impossible when no user specified
+            unset($sort_by);
+            unset($sort_order);
+        }
         $rows = Issue::getParam('rows');
         $hide_closed = Issue::getParam('hide_closed');
         if ($hide_closed === '') {
@@ -2484,6 +2729,7 @@
             "last_action_date" => "desc",
             "usr_full_name" => "asc",
             "iss_expected_resolution_date" => "desc",
+            "isu_order" => "desc",
         );
 
         foreach ($custom_fields as $fld_id => $fld_name) {
@@ -2669,7 +2915,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "issue_quarantine
                  ON
                     iss_id=iqu_iss_id AND
-                    (iqu_expiration > '" . Date_API::getCurrentDateGMT() . "' OR iqu_expiration IS NULL)
+                    (iqu_expiration > '" . Date_Helper::getCurrentDateGMT() . "' OR iqu_expiration IS NULL)
                  WHERE
                     iss_prj_id= " . Misc::escapeInteger($prj_id);
         $stmt .= Issue::buildWhereClause($options);
@@ -2691,7 +2937,7 @@
         $stmt .= "
                  LIMIT
                     " . Misc::escapeInteger($start) . ", " . Misc::escapeInteger($max);
-        $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return array(
@@ -2722,8 +2968,8 @@
             $csv[] = @implode("\t", $column_headings);
             for ($i = 0; $i < count($res); $i++) {
                 $res[$i]["time_spent"] = Misc::getFormattedTime($res[$i]["time_spent"]);
-                $res[$i]["iss_created_date"] = Date_API::getFormattedDate($res[$i]["iss_created_date"]);
-                $res[$i]["iss_expected_resolution_date"] = Date_API::getSimpleDate($res[$i]["iss_expected_resolution_date"], false);
+                $res[$i]["iss_created_date"] = Date_Helper::getFormattedDate($res[$i]["iss_created_date"]);
+                $res[$i]["iss_expected_resolution_date"] = Date_Helper::getSimpleDate($res[$i]["iss_expected_resolution_date"], false);
                 $fields = array(
                     $res[$i]['pri_title'],
                     $res[$i]['iss_id'],
@@ -2811,9 +3057,9 @@
                 $last_date = $result[$i]["iss_last_public_action_date"];
             }
             $date = new Date($last_date);
-            $current = new Date(Date_API::getCurrentDateGMT());
+            $current = new Date(Date_Helper::getCurrentDateGMT());
             $result[$i]['last_action_date'] = sprintf("%s: %s ago", ucwords($label),
-                    Date_API::getFormattedDateDiff($current->getDate(DATE_FORMAT_UNIXTIME), $date->getDate(DATE_FORMAT_UNIXTIME)));
+                    Date_Helper::getFormattedDateDiff($current->getDate(DATE_FORMAT_UNIXTIME), $date->getDate(DATE_FORMAT_UNIXTIME)));
         }
     }
 
@@ -2845,7 +3091,7 @@
                     $result[$i]['status_change_date'] = '';
                     continue;
                 }
-                $current = new Date(Date_API::getCurrentDateGMT());
+                $current = new Date(Date_Helper::getCurrentDateGMT());
                 $desc = "$label: %s ago";
                 $target_date = $result[$i][$date_field_name];
                 if (empty($target_date)) {
@@ -2853,7 +3099,7 @@
                     continue;
                 }
                 $date = new Date($target_date);
-                $result[$i]['status_change_date'] = sprintf($desc, Date_API::getFormattedDateDiff($current->getDate(DATE_FORMAT_UNIXTIME), $date->getDate(DATE_FORMAT_UNIXTIME)));
+                $result[$i]['status_change_date'] = sprintf($desc, Date_Helper::getFormattedDateDiff($current->getDate(DATE_FORMAT_UNIXTIME), $date->getDate(DATE_FORMAT_UNIXTIME)));
             }
         }
     }
@@ -2975,7 +3221,7 @@
                         if (strlen($options[$field_name]['time_period']) == 0) {
                             $options[$field_name]['time_period'] = 0;
                         }
-                        $stmt .= " AND (UNIX_TIMESTAMP('" . Date_API::getCurrentDateGMT() . "') - UNIX_TIMESTAMP(iss_$field_name)) <= (" .
+                        $stmt .= " AND (UNIX_TIMESTAMP('" . Date_Helper::getCurrentDateGMT() . "') - UNIX_TIMESTAMP(iss_$field_name)) <= (" .
                             Misc::escapeInteger($options[$field_name]['time_period']) . "*3600)";
                         break;
                 }
@@ -3151,7 +3397,7 @@
                  ORDER BY
                     " . $sort_by . " " . Misc::escapeString($options["sort_order"]) . ",
                     iss_id DESC";
-        $res = $GLOBALS["db_api"]->dbh->getCol($stmt);
+        $res = Db_Helper::getInstance()->getCol($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -3190,7 +3436,7 @@
                  WHERE
                     isu_iss_id=" . Misc::escapeInteger($issue_id) . " AND
                     isu_usr_id=usr_id";
-        $res = $GLOBALS["db_api"]->dbh->getCol($stmt);
+        $res = Db_Helper::getInstance()->getCol($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return array();
@@ -3243,7 +3489,7 @@
                  WHERE
                     iss_usr_id=usr_id AND
                     iss_id IN ($ids)";
-        $res = $GLOBALS["db_api"]->dbh->getAssoc($stmt);
+        $res = Db_Helper::getInstance()->getAssoc($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
         } else {
@@ -3276,6 +3522,8 @@
         $ids = implode(", ", $ids);
         $stmt = "SELECT
                     isu_iss_id,
+                    isu_order,
+                    isu_usr_id,
                     usr_full_name
                  FROM
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "issue_user,
@@ -3283,10 +3531,11 @@
                  WHERE
                     isu_usr_id=usr_id AND
                     isu_iss_id IN ($ids)";
-        $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
         } else {
+            // gather names of the users assigned to each issue
             $t = array();
             for ($i = 0; $i < count($res); $i++) {
                 if (!empty($t[$res[$i]['isu_iss_id']])) {
@@ -3295,9 +3544,18 @@
                     $t[$res[$i]['isu_iss_id']] = $res[$i]['usr_full_name'];
                 }
             }
+            // gather orders
+            $o = array();
+            for ($i = 0; $i < count($res); $i++) {
+                if (empty($o[$res[$i]['isu_iss_id']])) {
+                    $o[$res[$i]['isu_iss_id']] = array();
+                }
+                $o[$res[$i]['isu_iss_id']][$res[$i]['isu_usr_id']] = $res[$i]['isu_order'];
+            }
             // now populate the $result variable again
             for ($i = 0; $i < count($result); $i++) {
                 @$result[$i]['assigned_users'] = $t[$result[$i]['iss_id']];
+                @$result[$i]['assigned_users_order'] = $o[$result[$i]['iss_id']];
             }
         }
     }
@@ -3329,7 +3587,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "issue
                  WHERE
                     iss_id in ($ids)";
-        $res = $GLOBALS["db_api"]->dbh->getAssoc($stmt);
+        $res = Db_Helper::getInstance()->getAssoc($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
         } else {
@@ -3358,7 +3616,7 @@
                  WHERE
                     isu_iss_id=" . Misc::escapeInteger($issue_id) . " AND
                     isu_usr_id=usr_id";
-        $res = $GLOBALS["db_api"]->dbh->getCol($stmt);
+        $res = Db_Helper::getInstance()->getCol($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return array();
@@ -3424,7 +3682,7 @@
                  WHERE
                     iss_id=$issue_id AND
                     iss_prj_id=prj_id";
-        $res = $GLOBALS["db_api"]->dbh->getRow($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getRow($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
